# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class LogProfile(pulumi.CustomResource):
    """
    Manages a [Log Profile](https://docs.microsoft.com/en-us/azure/monitoring-and-diagnostics/monitoring-overview-activity-logs#export-the-activity-log-with-a-log-profile). A Log Profile configures how Activity Logs are exported.
    
    -> **NOTE:** It's only possible to configure one Log Profile per Subscription. If you are trying to create more than one Log Profile, an error with `StatusCode=409` will occur.
    """
    def __init__(__self__, __name__, __opts__=None, categories=None, locations=None, name=None, retention_policy=None, servicebus_rule_id=None, storage_account_id=None):
        """Create a LogProfile resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not categories:
            raise TypeError('Missing required property categories')
        __props__['categories'] = categories

        if not locations:
            raise TypeError('Missing required property locations')
        __props__['locations'] = locations

        __props__['name'] = name

        if not retention_policy:
            raise TypeError('Missing required property retention_policy')
        __props__['retention_policy'] = retention_policy

        __props__['servicebus_rule_id'] = servicebus_rule_id

        __props__['storage_account_id'] = storage_account_id

        super(LogProfile, __self__).__init__(
            'azure:monitoring/logProfile:LogProfile',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

